﻿using System;
using System.Data.SqlClient;
using System.Configuration;
using System.Data;

public partial class Basic_Modify : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // 넘겨져 온 번호 값 검사
        if (String.IsNullOrEmpty(Request["Num"]))
        {
            Response.Write("잘못된 요청입니다.");
            Response.End();
        }
        else
        {
            if (!Page.IsPostBack) // 반드시 수정페이지는 처음로드시에만 이전 데이터 읽어오자.
            {
                // 넘겨져 온 번호값에 해당하는 글 출력
                DisplayData();
            }
        }
    }
    private void DisplayData()
    {
        // View.aspx와 동일 패턴
        SqlConnection conn = new SqlConnection(
            ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString);
        conn.Open();
        SqlCommand cmd = new SqlCommand("ViewBasic", conn);
        cmd.CommandType = CommandType.StoredProcedure;
        // 파라미터 : List.aspx에서 넘겨온 쿼리스트링값
        cmd.Parameters.AddWithValue("@Num", Request["Num"]);
        // 상세보기 : DataReader
        SqlDataReader dr = cmd.ExecuteReader();
        // 바인딩 : 각각의 컨트롤
        while (dr.Read()) {
            this.lblNum.Text = dr["Num"].ToString();
            this.txtName.Text = dr["Name"].ToString();
            this.txtEmail.Text = dr["Email"].ToString();
            this.txtHomepage.Text = dr["Homepage"].ToString();
            this.txtTitle.Text = dr["Title"].ToString();
            this.txtContent.Text = dr["Content"].ToString(); // 
            string encoding = dr["Encoding"].ToString(); // Text/Html/Mixed
            if (encoding == "HTML") {// 입력한 모양 그대로 출력            
                this.lstEncoding.SelectedIndex = 1; 
            }
            else if (encoding == "Mixed") {// 태그는 실행하되, 엔터는 처리            
                this.lstEncoding.SelectedIndex = 2; 
            }
        }
        dr.Close();
        conn.Close(); 
    }
    protected void btnModify_Click(object sender, EventArgs e)
    {
        if (IsPasswordCorrect()) {
            // Write.aspx 페이지와 동일 패턴
            SqlConnection objCon = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString);

            SqlCommand objCmd = new SqlCommand("ModifyBasic", objCon);
            objCmd.CommandType = CommandType.StoredProcedure;

            objCmd.Parameters.AddWithValue("@Name", txtName.Text);
            objCmd.Parameters.AddWithValue("@Email", txtEmail.Text);
            objCmd.Parameters.AddWithValue("@Title", txtTitle.Text);
            objCmd.Parameters.AddWithValue("@ModifyIP", Request.UserHostAddress); // IP주소
            objCmd.Parameters.AddWithValue("@ModifyDate", DateTime.Now); // IP주소
            objCmd.Parameters.AddWithValue("@Content", txtContent.Text);
            objCmd.Parameters.AddWithValue("@Encoding", lstEncoding.SelectedValue);
            objCmd.Parameters.AddWithValue("@Homepage", txtHomepage.Text);
            objCmd.Parameters.AddWithValue("@Num", lblNum.Text);

            objCon.Open();
            objCmd.ExecuteNonQuery();
            objCon.Close();

            Response.Redirect("View.aspx?Num=" + Request["Num"]); // 상세보기로 가서 수정 확인 
        }
        else {
            lblError.Text = "암호가 틀립니다.";
        }
    }
    // 번호와 암호가 맞으면 참을 반환, 그렇지 않으면 거짓을 반환
    private bool IsPasswordCorrect()
    {
        bool result = false;
        SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString);
        conn.Open();
        SqlCommand cmd = new SqlCommand(
            "Select * From Basic Where Num = @Num And Password = @Password", conn);
        cmd.Parameters.AddWithValue("@Num", Request["Num"]);
        cmd.Parameters.AddWithValue("@Password", txtPassword.Text);
        SqlDataReader dr = cmd.ExecuteReader();
        while (dr.Read())
        {// 데이터가 읽혀진다면, 번호와 암호가 맞음 
            result = true;
        }
        return result;
    }
    protected void btnList_Click(object sender, EventArgs e)
    {
        // 리스트 페이지로 이동
        Response.Redirect("List.aspx");
    }
}
